package com.example.repeater;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.support.annotation.ColorInt;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;

public class ListViewAdapter extends BaseAdapter {
    // Adapter에 추가된 데이터를 저장하기 위한 ArrayList
    private ArrayList<ListViewItem> listViewItemList = new ArrayList<ListViewItem>() ;

    // ListViewAdapter의 생성자
    public ListViewAdapter() {

    }

    // Adapter에 사용되는 데이터의 개수를 리턴. : 필수 구현
    @Override
    public int getCount() {
        return listViewItemList.size() ;
    }

    // position에 위치한 데이터를 화면에 출력하는데 사용될 View를 리턴. : 필수 구현
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final int pos = position;
        final Context context = parent.getContext();

        // "listview_item" Layout을 inflate하여 convertView 참조 획득.
        if (convertView == null) {
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            convertView = inflater.inflate(R.layout.activity_list_view_item, parent, false);
        }

        // 화면에 표시될 View(Layout이 inflate된)으로부터 위젯에 대한 참조 획득
        TextView descTextView = (TextView) convertView.findViewById(R.id.textView13) ;
        TextView valTextView  = (TextView) convertView.findViewById(R.id.textView14) ;
        EditText valeditText  = (EditText) convertView.findViewById(R.id.editText) ;
        EditText valeditText1  = (EditText) convertView.findViewById(R.id.editText1) ;
        EditText valeditText2  = (EditText) convertView.findViewById(R.id.editText2) ;
        Button valbutton      = (Button) convertView.findViewById(R.id.button) ;

        // Data Set(listViewItemList)에서 position에 위치한 데이터 참조 획득
        ListViewItem listViewItem = listViewItemList.get(position);
        valTextView.setVisibility(View.VISIBLE);
        valeditText.setVisibility(View.VISIBLE);
        valbutton.setVisibility(View.VISIBLE);
        valeditText1.setVisibility(View.VISIBLE);
        valeditText2.setVisibility(View.VISIBLE);
        // 아이템 내 각 위젯에 데이터 반영
        descTextView.setText(listViewItem.getDesc());
        if(listViewItem.getMode() == "READ") {
            valTextView.setText(listViewItem.getVal());
            valeditText.setVisibility(View.INVISIBLE);
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.INVISIBLE);

        }
        else if(listViewItem.getMode() == "EDIT") {
            valTextView.setVisibility(View.INVISIBLE);
            valeditText.setText(listViewItem.getVal());
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.INVISIBLE);
        }
        else if(listViewItem.getMode() == "EDIT2") {
            valTextView.setVisibility(View.INVISIBLE);
            valeditText1.setVisibility(View.VISIBLE);
            valeditText2.setVisibility(View.VISIBLE);
            valeditText.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.INVISIBLE);
            valeditText1.setText(listViewItem.getVal());
            valeditText2.setText(listViewItem.getVal2());
        }
        else if(listViewItem.getMode() == "BUTTON") {
            valTextView.setVisibility(View.INVISIBLE);
            valeditText.setVisibility(View.INVISIBLE);
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.VISIBLE);
            valbutton.setText(listViewItem.getVal());
        }else{
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valTextView.setVisibility(View.INVISIBLE);
            valeditText.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.VISIBLE);
            //   valbutton.setText(listViewItem.getVal());
        }

//        descTextView.setBackgroundColor();
        return convertView;
    }

    // 지정한 위치(position)에 있는 데이터와 관계된 아이템(row)의 ID를 리턴. : 필수 구현
    @Override
    public long getItemId(int position) {
        return position ;
    }

    // 지정한 위치(position)에 있는 데이터 리턴 : 필수 구현
    @Override
    public Object getItem(int position) {
        return listViewItemList.get(position) ;
    }

    // 아이템 데이터 추가를 위한 함수. 개발자가 원하는대로 작성 가능.
    public void addItem(String desc,String val,String val2,String mode) {
        ListViewItem item = new ListViewItem();

        item.setDesc(desc);
        item.setMode(mode);
        item.setVal(val);
        item.setVal2(val2);

        listViewItemList.add(item);
    }
}