package com.example.repeater;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.ToggleButton;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.util.ArrayList;
import java.util.HashMap;

public class MainActivity extends AppCompatActivity implements Runnable {
    private ListView listview_info;
    private ListView listview_rf;
    private ListView listview_info_set;
    private ListView listview_rf_set;
    /*** WIFI Start***/
    BufferedReader in;      //서버로부터 온 데이터를 읽는다.
    PrintWriter out;        //서버에 데이터를 전송한다.
    TextView textView_status;
    String data;
    Button button_port,button_control;
    private Socket socket;  //소켓생성


    public boolean isConnection_Status() {
        return Connection_Status;
    }

    public void setConnection_Status(boolean connection_Status) {
        Connection_Status = connection_Status;
        if(connection_Status){
            Log.d("Port Close", "성공");
            button_port.setText("Port Close");
        }else{
            Log.d("Port Open", "성공");
            button_port.setText("Port Open");
        }
    }

    /*** WIFI END***/
    private boolean Connection_Status = false;

    ImageButton imageButton01;
    ImageButton imageButton02;
    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);


        imageButton01 = findViewById(R.id.imageButton01);
        imageButton02 = findViewById(R.id.imageButton02);

        listview_info = findViewById(R.id.listview_info);
        listview_rf = findViewById(R.id.listview_rf);
        listview_info_set = findViewById(R.id.listview_info_set);
        listview_rf_set = findViewById(R.id.listview_rf_set);


        imageButton02 = findViewById(R.id.imageButton02);

        button_port = findViewById(R.id.button_port);
        button_control = findViewById(R.id.button_control);
        textView_status = findViewById(R.id.textView_status);
        ListView listview ;
        ListViewAdapter adapter_infor;
        ListViewAdapter adapter_rf;
        ListViewAdapter adapter_info_set;
        ListViewAdapter adapter_rf_set;

        // Adapter 생성
        adapter_infor = new ListViewAdapter() ;
        adapter_rf = new ListViewAdapter();
        adapter_info_set = new ListViewAdapter() ;
        adapter_rf_set = new ListViewAdapter();

        // 리스트뷰 참조 및 Adapter달기
        listview = (ListView) findViewById(R.id.listview_info);
        listview.setAdapter(adapter_infor);


        adapter_infor.addItem("firm info.","0.1Ver","","READ");
        adapter_infor.addItem("FPGA Ver.","0.2Ver","","READ");
        adapter_infor.addItem("F/W Ver.","0.3Ver","","READ");
        adapter_infor.addItem("Config No.","0.4Ver","","READ");
        adapter_infor.addItem("Sub Frame No.","0.5Ver","","READ");
        adapter_infor.addItem("CH1 TTG","0.6Ver","","READ");
        adapter_infor.addItem("CH1 RTG","0.7Ver","","READ");
        adapter_infor.addItem("CH2 TTG","0.8Ver","","READ");
        adapter_infor.addItem("CH2 RTG","0.9Ver","","READ");
        adapter_infor.addItem("CH1 Polarity","1.1Ver","","READ");
        adapter_infor.addItem("CH1 Default","1.2Ver","","READ");
        adapter_infor.addItem("CH2 Polarity","1.1Ver","","READ");
        adapter_infor.addItem("CH2 Default","1.2Ver","","READ");
        adapter_infor.addItem("Auto Config","1.3Ver","","READ");

        listview = (ListView) findViewById(R.id.listview_info_set);
        listview.setAdapter(adapter_info_set);
        adapter_info_set.addItem("firm info.","0.1Ver","","READ");
        adapter_info_set.addItem("FPGA Ver.","0.2Ver","","READ");
        adapter_info_set.addItem("F/W Ver.","0.3Ver","","READ");
        adapter_info_set.addItem("Config No.","0.4Ver","","EDIT");
        adapter_info_set.addItem("Sub Frame No.","0.5Ver","","EDIT");
        adapter_info_set.addItem("CH1 TTG","0.6Ver","","EDIT");
        adapter_info_set.addItem("CH1 RTG","0.7Ver","","EDIT");
        adapter_info_set.addItem("CH2 TTG","0.8Ver","","EDIT");
        adapter_info_set.addItem("CH2 RTG","0.9Ver","","EDIT");
        adapter_info_set.addItem("CH1 Polarity","1.1Ver","","BUTTON");
        adapter_info_set.addItem("CH1 Default","1.2Ver","","BUTTON");
        adapter_info_set.addItem("CH2 Polarity","1.1Ver","","BUTTON");
        adapter_info_set.addItem("CH2 Default","1.2Ver","","BUTTON");
        adapter_info_set.addItem("Auto Config","1.3Ver","","BUTTON");

        listview = (ListView) findViewById(R.id.listview_rf);
        listview.setAdapter(adapter_rf);
        adapter_rf.addItem("input ATT","0.1Ver","","READ");
        adapter_rf.addItem("Output ATT","0.2Ver","","READ");
        adapter_rf.addItem("Input Offset ATT","0.3Ver","","READ");
        adapter_rf.addItem("Output Offset ATT","0.4Ver","","READ");
        adapter_rf.addItem("Gain(dB)","0.5Ver","","READ");
        adapter_rf.addItem("ALC Level","0.6Ver","","READ");
        adapter_rf.addItem("PA Enable","0.7Ver","","READ");
        adapter_rf.addItem("EX PA Enable","0.8Ver","","READ");
        adapter_rf.addItem("RF PLL Freq","0.9Ver","","READ");
        adapter_rf.addItem("AGD Level","1.1Ver","","READ");
        adapter_rf.addItem("ISO Level","1.2Ver","","READ");
        adapter_rf.addItem("Temperature","1.3Ver","","READ");

        listview = (ListView) findViewById(R.id.listview_rf_set);
        listview.setAdapter(adapter_rf_set);
        adapter_rf_set.addItem("input ATT","","","EDIT2");
        adapter_rf_set.addItem("Output ATT","","","EDIT2");
        adapter_rf_set.addItem("Input Offset ATT","","","EDIT2");
        adapter_rf_set.addItem("Output Offset ATT","","","EDIT2");
        adapter_rf_set.addItem("Gain(dB)","","","EDIT2");
        adapter_rf_set.addItem("ALC Level","","","EDIT2");
        adapter_rf_set.addItem("PA Enable","0.7Ver","","BUTTON");
        adapter_rf_set.addItem("EX PA Enable","0.8Ver","","BUTTON");
        adapter_rf_set.addItem("RF PLL Freq","","","EDIT");
        adapter_rf_set.addItem("AGD Level","","","EDIT");
        adapter_rf_set.addItem("ISO Level","1.2Ver","","READ");
        adapter_rf_set.addItem("Temperature","1.3Ver","","READ");
    }
    public void onClick(View view) {
        switch(view.getId()) {
            case R.id.button_port:
                if(button_port.getText() == "Port Close") {
                    setConnection_Status(false);
                }
                else {
                    // 버튼을 누르는 이벤트 발생, 이벤트 제어문이기 때문에 이벤트 발생 때마다 발동된다. 시스템이 처리하는 부분이 무한루프문에
                    //있더라도 이벤트가 발생하면 자동으로 실행된다.
                    try{
                        Runnable start = new MainActivity();
                        Thread T = new Thread(start);
                        T.start();
                        Log.d("MainActivity / 쓰레드 실행","성공");
                        setConnection_Status(true);
                    }catch (Exception e){
                        Log.e("MainActivity / 쓰레드 실행","실패");
                    }
                }
                break;
            case R.id.button_control:
                if(button_control.getText() == "Status") {
                    button_control.setText("Control");
                    textView_status.setText("Status");
                    if(listview_info_set.getVisibility() == view.VISIBLE) {
                        listview_info.setVisibility(view.VISIBLE);
                        listview_info_set.setVisibility(view.INVISIBLE);
                        listview_rf.setVisibility(view.INVISIBLE);
                        listview_rf_set.setVisibility(view.INVISIBLE);
                    }else{
                        listview_rf.setVisibility(view.VISIBLE);
                        listview_rf_set.setVisibility(view.INVISIBLE);
                        listview_info.setVisibility(view.INVISIBLE);
                        listview_info_set.setVisibility(view.INVISIBLE);
                    }
                }
                else {
                    button_control.setText("Status");
                    textView_status.setText("Control");
                    if(listview_info.getVisibility() == view.VISIBLE) {
                        listview_info.setVisibility(view.INVISIBLE);
                        listview_info_set.setVisibility(view.VISIBLE);
                        listview_rf.setVisibility(view.INVISIBLE);
                        listview_rf_set.setVisibility(view.INVISIBLE);
                    }else{
                        listview_rf.setVisibility(view.INVISIBLE);
                        listview_rf_set.setVisibility(view.VISIBLE);
                        listview_info.setVisibility(view.INVISIBLE);
                        listview_info_set.setVisibility(view.INVISIBLE);
                    }
                }
                break;
            case R.id.imageButton01:
                if(textView_status.getText() != "Control") {
                    listview_info.setVisibility(view.VISIBLE);
                    listview_rf.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.INVISIBLE);

                    listview_rf_set.setVisibility(view.INVISIBLE);
                }else{
                    listview_info.setVisibility(view.INVISIBLE);
                    listview_rf.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.INVISIBLE);

                    listview_info_set.setVisibility(view.VISIBLE);
                }
                break;
            case R.id.imageButton02:
                if(textView_status.getText() != "Control") {
                    listview_info.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.INVISIBLE);

                    listview_rf.setVisibility(view.VISIBLE);
                }else{
                    listview_info.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.VISIBLE);

                    listview_rf.setVisibility(view.INVISIBLE);
                }
                break;
        }
    }

    @Override
    public void run() {
        connect con = new connect(this);
        con.run();
        try {
            Log.d("MainActivity / Run 함수 실행", "성공");
        }catch(Exception e){
            Log.e("MainActivity / Run 함수 실행", "실패");
            setConnection_Status(false);
        }

    }
}
